class vcDragContainer extends HTMLElement 
{ constructor() 
  { super();
    this.HasBeenConnected = false;
    this.DragSingle = new vcDragSingle(); 
    this.OnDropCallback = null;
    this.ParentDraggable = null; 
    if (vcDragSingle.OnCreateDrag) return;
    this.addEventListener('dragenter',this._onDragenter.bind(this));
    this.addEventListener('dragleave',this._onDragleave.bind(this));
    this.addEventListener('dragover',this._onDragover.bind(this));
    this.addEventListener('drop',this._onDrop.bind(this));
  } 

 connectedCallback()  
  { //console.log("container in connected callback"); 
    if (this.HasBeenConnected==true) return; 
    this.HasBeenConnected = true;
    //console.log('Drag container added to page.');
    this.GroupIx = this.DragSingle.GetGroupIndex(this);
    this.setAttribute('vc-dragover','');
  } 
  
  disconnectedCallback()  
  { //console.log("container in disconnected callback");
  } 
  
  
//PUBLIC METHODS
  DeleteAll()
  { var el;
    var own;
    var nx;
    do
    { var el = this.firstChild; 
      if (el==null) break;
      if (el.nodeName!="VC-DRAGITEM") 
      { el.remove();
        continue;
      }
      this.DragSingle.DeleteDragItem(el); 
    } while (true);
  }

//**  
//
//  
  GetDragItem(ItemName)
  { var nxt; 
    var el  = this;
    do
    { if ((nxt = el.firstElementChild)!=null) 
      { el = nxt;
        if (el.nodeName=='VC-DRAGITEM')
        { if (el.id==ItemName) return el;
          if (el.hasAttribute('vc-dragclone'))
          { if (el.getAttribute('vc-clonedid')==ItemName) return el; 
          }
        }
        continue;
      }
      do
      { if ((el==this)||(el==null)) break;
        if ((nxt=el.nextElementSibling)!=null) 
        { el = nxt;
          if (el.nodeName=='VC-DRAGITEM')
          { if (el.id==ItemName) return el;
            if (el.hasAttribute('vc-dragclone'))
            { if (el.getAttribute('vc-clonedid')==ItemName) return el; 
            }
          }
          break;
        }
        el = el.parentElement;
      } while (true);
      if ((el==this)||(el==null)) break;
    } while (true);
    return null;
  }

 
  
  RestoreDragConnections(Restore)
  { if (Restore==null) return;
    this.DragSingle.RestoreDragConnections(Restore);
  }
  
  
  SaveDragConnections(TheObject)
  { this.DragSingle.SaveDragConnections(this,TheObject);
  }
 
   
  MoveToThis()
  { if (vcDragSingle.SelOwners[this.GroupIx]==null) return;
    if (vcDragSingle.SelOwners[this.GroupIx]==this) return;
    this.doDrop(this);
  }
  
//GETTERS AND SETTERS
  
  SetCallback(TheCallback) 
  { console.log("Set");   
    this.OnDropCallback = TheCallback; 
  }
  
  SetDummyContainer(Dummy) 
  { vcDragSingle.Dummy = Dummy; 
  }
  

//EVENT HANDLERS
  
  _onDragenter(ev)
  {  
    var el = this.DragSingle.GetDragElement(ev.target);
    if (el==null) return; 
    var fg = this.DragSingle.CanDrop(el);
    if (!fg) return;
//  console.log("drag enter on " + el.id);
    var s = el.getAttribute('vc-dragover') + '0';
    el.setAttribute('vc-dragover',s); 
    ev.preventDefault();
  }
 
  _onDragover(ev)
  { var el = this.DragSingle.GetDragElement(ev.target);
    if (el==null) return;
    var fg = this.DragSingle.CanDrop(el);
    if (!fg) return;
    ev.preventDefault();
  }
      
  _onDragleave(ev) 
  { var el = this.DragSingle.GetDragElement(ev.target); 
    if (el==null) return;
    var fg = this.DragSingle.CanDrop(el);
    if (!fg) return;
//  console.log("drag leave on " + el.id);
    var s = el.getAttribute('vc-dragover'); 
    if (s!='') s = s.substr(1);
    el.setAttribute('vc-dragover',s);  
  }
      
  _onDrop(ev)  
  { ev.preventDefault();
    var el  = this.DragSingle.ModifyDropTarget(ev.target,ev.dataTransfer.getData("text"));
    if (el==null) return; 
    ev.stopPropagation();
    var cnt;
    if (el.nodeName=='VC-DRAGITEM') 
         cnt = el.parentElement;
    else cnt = el;
    this._doDrop(cnt,el);
//    if (vcDragSingle.Selected[cnt.GroupIx]!=null) 
//      vcDragSingle.Selected[cnt.GroupIx].focus()
    if (cnt.OnDropCallback!=null)
    { 
      cnt.OnDropCallback(cnt);
    }
//  ev.stopPropagation();
  }
  
  
//STATIC FUNCTIONS FOR vcDaDItem  



  
//PRIVATE FUNCTIONS

//Drop selected vc-dragitems onto Container from the owner of the selected
//items at the same GroupIx.
//Target is either i) a child of Container  
//                 2) the Container itself
//
  _doDrop(Container,Target)
  { var cln,nxt;
    console.log("doing drop"); 
    var ix  = Container.GroupIx;
    var el  = vcDragSingle.SelOwners[ix]; 
    if (el==null) return;
    var dup = false;
    if (el.hasAttribute("vc-source")) dup = true;
    if (el==Container) dup = false;
    var arr = this.DragSingle.ListDragItems(ix);
    console.log("" + arr);
    for (var i=0;i<arr.length;i++)
    { el = arr[i];
      if (dup)
      { cln = el.cloneNode(true); 
			  cln.setAttribute("vc-clonedid",el.id);
        cln.removeAttribute('id');
        cln.setAttribute("vc-dragclone","");
        cln.setAttribute("vc-candelete","");
        cln.setAttribute('vc-selected','true');
        console.log ("clone selected = " + cln.getAttribute('vc-selected'));
        el.setAttribute('vc-selected','false'); 
        el = cln;
      }
      if (Target==Container)
             Target.appendChild(el);
      else 
      { if (el!=Target) 
          Container.insertBefore(el,Target);
      }
    }
    vcDragSingle.SelOwners[ix] = Container;
  }
}

customElements.define('vc-dragcontainer', vcDragContainer);
      
