class vcDragItem extends HTMLElement 
{

  constructor() 
  { super();
//  console.log('Dragitem constructor.'); 
    this.HasBeenConnected = false;
    this.DragSingle = new vcDragSingle(); 
	  if (vcDragSingle.OnCreateDrag) return;
    this.addEventListener('dragstart',this._onDragstart.bind(this));
    this.addEventListener('dragend',this._onDragend.bind(this));
    this.addEventListener('click',this._onClick.bind(this));
    this.addEventListener('keydown',this._onKeydown.bind(this));
  }
  
 connectedCallback() 
  { if (this.HasBeenConnected==true) return; 
//  console.log('Drag item in connected callback.');
	  if (vcDragSingle.OnCreateDrag) return;
    this.setAttribute('draggable','true');
    this.setAttribute('vc-selected','false');
    this.setAttribute('vc-dragover','');
    this.GroupIx = this.DragSingle.GetGroupIndex(this);
    this.HasBeenConnected = true;
  } 
  
  disconnectedCallback() 
  { //console.log('Drag item disconnected.');
  } 
  
//PUBLIC METHODS
  
  
  
  
//GETTERS AND SETTERS
  
  set Callback(callback) 
  {    
    //this.Cbk = callback;
  }
  
  
  
//EVENT HANDLERS
  
  
  _onClick(ev)
  { ev.preventDefault(); 
    var el = this.DragSingle.GetDragElement(ev.target);
    if (el==null) return;
    ev.stopPropagation();
    if (!el.getAttribute('draggable')) return;
    if (ev.ctrlKey||ev.shiftKey||ev.metaKey)
    { if (ev.shiftKey)
      { this._doShift(el);
      }
      else
      { //if (IsMac);
        var par = el.parentNode;
        var ix  = this.GroupIx;
        if (vcDragSingle.SelOwners[ix]!=null)
          if (par!=vcDragSingle.SelOwners[ix]) return;
        if (el.getAttribute('vc-selected')=='true')
             this.DragSingle.DeselectDragItem(el);
        else this.DragSingle.SelectDragItem(el);
      }
    }
    else
    { this.DragSingle.ClearSelection(this.GroupIx); 
      this.DragSingle.SelectDragItem(el);
    }
//  this.doCbk(); 
  }
 
  _onDragstart(ev)
  { 
//  ev.preventDefault();
    ev.stopPropagation();
    var el = ev.target;
    if (el.getAttribute('vc-selected')=='false')
    { this.DragSingle.ClearSelection(el.GroupIx);
      this.DragSingle.SelectDragItem(el);
    }
    ev.dataTransfer.setData("text",ev.target.GroupIx);
	  vcDragSingle.OnCreateDrag = true;
    var dm = this.DragSingle.CreateDragList(this.GroupIx,el);
	  vcDragSingle.OnCreateDrag = false;
    if (dm!=null) ev.dataTransfer.setDragImage(dm, 50, 50);
	  vcDragSingle.DragGroupIx = this.GroupIx; 
  }
 
  _onDragend(ev)
  {  
//  ev.preventDefault();
//  console.log("drag end");
    this.DragSingle.DestroyDragList();
	  vcDragSingle.DragGroupIx = -1; 
  }

  _onKeydown(ev)
  {  
//  ev.preventDefault();
//  console.log("keypressed = " + ev.which); 
    if (ev.which==46) 
    { if (this.hasAttribute("vc-candelete"))
      { this.DragSingle.DeleteDragItem(this);
      }
      ev.stopPropagation();
    }
  }


  
//PRIVATE FUNCTIONS
 
  
  _doShift(Target)
  { var par = Target.parentNode;
    var stt = Target;
    var end = Target;
    var sfg = false;
    if (vcDragSingle.SelOwners[this.GroupIx]!=null)
    { if (par!=vcDragSingle.SelOwners[this.GroupIx]) return;
      stt = null;
      end = null;
      var el = par.firstElementChild;
      while (el!=null)
      { if (el.hasAttribute('vc-selected'))
        { if ((el.getAttribute('vc-selected')=='true')||(el==Target))
          { if (stt==null) 
            { stt = el;
              if ((el.getAttribute('vc-selected')=='true')&&(el==Target))
                sfg = true;
            }
            end = el;
          }
        }
        el = el.nextElementSibling;
      }
      this.DragSingle.ClearSelection(this.GroupIx);
    }
    if ((stt!=Target)&&(end!=Target)) end = Target;
    if (sfg) end = Target;
    do
    { if (stt.hasAttribute('vc-selected'))
      { this.DragSingle.SelectDragItem(stt);
        if (stt==end) break;
      }
      stt = stt.nextElementSibling;
    } while (stt!=null);
  }
}


customElements.define('vc-dragitem', vcDragItem);