class vcDragSingle 
{

  constructor() 
  { if (vcDragSingle._instance) 
    { 
//    console.log("returning existing instance"  ); 
      return(vcDragSingle._instance);
    }
//  console.log("creating instance");
    vcDragSingle._instance    = this;
    vcDragSingle.Groups           = [];
    vcDragSingle.Groups.push("0");
		vcDragSingle.SelOwners        = [];
    vcDragSingle.SelOwners.length = 1;
    vcDragSingle.SelOwners[0]     = null;
		vcDragSingle.Dummy        = null;
		vcDragSingle.Cbk          = null;
		vcDragSingle.InCbk        = false;
		vcDragSingle.OnCreateDrag = false;
  }

  
//**
//Test if allowed to drop current drag group onto given DropTarget. The
//DropTarget is either a vcDragContainer or a vcDragItem.
//  
  CanDrop(DropTarget)
  { var el = DropTarget;
    var ix = el.GroupIx;
    var ndnm = el.nodeName;
    if (vcDragSingle.DragGroupIx!=ix) 
    { if (ndnm=='VC-DRAGCONTAINER') return false;
      el = this.GetChildContainer(el);
      if (el==null) return false;
      if (el.GroupIx!=vcDragSingle.DragGroupIx) return false; 
      ndnm = 'VC-DRAGCONTAINER';
    }
    if (!(this.IsDraggingClones(ix))) return true;
    while (ndnm!='VC-DRAGCONTAINER')
    { el = el.parentElement;
      if (el==null) return false;
      ndnm = el.nodeName;
    }
    return (!(el.hasAttribute('vc-source')));  
  }
  
  
//**
//Clear selected items at given selection Index
//  
  ClearSelection(Index)
  { var el = vcDragSingle.SelOwners[Index]; 
    if (el==null) return;
    el = el.firstElementChild;
    while (el!=null)
    { if (el.nodeName=='VC-DRAGITEM')
        this.DeselectDragItem(el);
      el = el.nextElementSibling;
    }
    vcDragSingle.SelOwners[Index] = null;
  }
  
  
//**
//Create and return drag list image if dummy container exists.
//Clone all of the selected vcDragItems which are children of
//the given vcDragItem's parent vcDragContainer.
//  
  CreateDragList(GroupIx,DragItem) 
  { var cln;
    var dm = vcDragSingle.Dummy;
    if (dm==null) return null;
    this.DestroyDragList();
    var el = DragItem.parentElement;
    if (el==null) return null;
    if (el.nodeName!='VC-DRAGCONTAINER') return null;
    el = el.firstElementChild;
    while (el!=null)
    { if (el.nodeName=='VC-DRAGITEM')
      { if (el.getAttribute('vc-selected')=='true')
        { cln = el.cloneNode(true);
          dm.appendChild(cln);
        }
      }
      el  = el.nextElementSibling;
    }
    var dumRect = dm.getBoundingClientRect();
    var clnRect = cln.getBoundingClientRect();
    vcDragSingle.Dummy.style.height = (clnRect.bottom - dumRect.top) + "px";
    return dm;
  }
 
  
//**  
//Delete the given valid vcDragItem
//
  DeleteDragItem(DragItem) 
  { DragItem.remove();
  }

  
//**  
//Make the given valid vcDragItem deselected
//
  DeselectDragItem(DragItem) 
  { DragItem.setAttribute('vc-selected','false');
  }

  
//**  
//Destroy drag list if dummy container exists
//
  DestroyDragList() 
  { 
    var dm = vcDragSingle.Dummy;
    if (dm==null) return;
    while (dm.firstElementChild!=null)
      dm.firstElementChild.remove();
  }


//**  
//Find DragItem's child DragContainer if exists
//  
  GetChildContainer(DragItem)
  { var el = DragItem.firstElementChild;
    while (el!=null)
    { if (el.nodeName=='VC-DRAGCONTAINER') break;
      el = el.nextElementSibling;
    }
    return (el);
  }

  
//**  
//Find DragItem's child DragContainer if exists
//  
  GetDragCloseButton(DragItem)
  { var el = DragItem.firstElementChild;
    if (el==null) return null;
    if (el.nodeName=='VC-DRAGCLOSEBUTTON') return el;
    el = el.firstElementChild;
    if (el==null) return null; 
    if (el.nodeName=='VC-DRAGCLOSEBUTTON') return el;
	  return null;
  }

  
//**
//Determine whether the given Element (or its parents) is a vcDragContainer 
//or a vcDragItem and return the earliest such example or null
//  
  GetDragElement(Element)
  { var ndnm;
    var el = Element;
    do
    { ndnm = el.nodeName;
      if (ndnm=='VC-DRAGCONTAINER') break;
      if (ndnm=='VC-DRAGITEM') break;
      el = el.parentElement;
    } while (el!=null);
    return(el);
  }
  
  
//**   
//Returns the drop group index for this drag element, creating a new one if
//necessary.
//  
  GetGroupIndex(el) 
  { 
    if (!el.hasAttribute("vc-dropgroup")) return 0;
    var attr = el.getAttribute("vc-dropgroup");
    if (attr=="0") return 0;
    var ix = vcDragSingle.Groups.indexOf(attr);
    if (ix>0) return ix;
    vcDragSingle.Groups.push(attr);
    ix = vcDragSingle.Groups.length - 1;
    vcDragSingle.SelOwners.length = ix+1;
		vcDragSingle.SelOwners[ix]    = null;
    return ix;
  }
  
  
//**  
//Find DragItem's child DragContainer if exists
//  
  IsDraggingClones(Index)
  { var el = vcDragSingle.SelOwners[Index];
    if (el==null) return false;
    el = el.firstElementChild;
    while (el!=null)
    { if (el.hasAttribute('vc-dragclone')) return true;
      el = el.nextElementSibling;
    }
    return false;
  }
  
  
//**  
//
//  
  ListDragItems(GroupIx) 
  { var el  = vcDragSingle.SelOwners[GroupIx]; 
    if (el==null) return null;
    el = el.firstElementChild; 
    var arr = [];
    while (el!=null)
    {	if (el.getAttribute('vc-selected')=='true')
        arr.push(el);
      el = el.nextElementSibling;
    }
    return arr;
  }
  
  
//**  
//
//  
  ModifyDropTarget(Target,GroupIx)
  { var el  = this.GetDragElement(Target);
    if (el==null) return null;
//  console.log("wants to drop on " + Target.id + " modified to " + el.id);
    el.setAttribute('vc-dragover','');
    if (el.GroupIx==GroupIx) return el;
    if (el.nodeName!='VC-DRAGITEM') return null; 
    el = this.GetChildContainer(el);
    if (el==null) return null;
    if (el.GroupIx!=GroupIx) return null;
    return el;
  }

  
//**  
//
//  
  RestoreDragConnections(Restore)
  { var key,val,id,ix,src,tgt,cln,cls;
    var arr = Object.keys(Restore);
    for (var i=0;i<arr.length;i++)
    { key = arr[i];
      val = Restore[key]; 
      id  = (key.split(":"))[0];
      cln = (key.includes(":"));
      ix  = val.indexOf(":DragCloseButton");
      cls = (ix>0);
      if (cls)  val = val.slice(0,ix);
      console.log("restoring " + id + " to " + val); 
      src = document.getElementById(id);
      tgt = document.getElementById(val); 
      if ((src==null)||(tgt==null)) continue; 
      if (tgt.nodeName!='VC-DRAGCONTAINER')
      { tgt = this.GetChildContainer(tgt);
        if (tgt==null) continue;
      }
      src= this.XferDragItem(src,tgt,tgt,cln,false);
      if ((cln)&&(src!=null)) src.id = key;
      if ((src!=null))
      { src = this.GetDragCloseButton(src);
        if (src!=null) src.Close(cls);
      }
    }
  }
  
  
//**  
//
//  
  SaveDragConnections(DragContainer,TheObject)
  { var nxt; 
    var ct = 0;
    var el  = DragContainer;
    do
    { if ((nxt = el.firstElementChild)!=null) 
      { el = nxt;
        if (el.nodeName=='VC-DRAGITEM')
        		this.SaveDragConnection(TheObject,el,ct++);
        continue;
      }
      do
      { if (el.hasAttribute('vc-dragclone')) el.removeAttribute('id');
        if ((el==DragContainer)||(el==null)) break;
        if ((nxt=el.nextElementSibling)!=null) 
        { el = nxt;
          if (el.nodeName=='VC-DRAGITEM')
          	this.SaveDragConnection(TheObject,el,ct++);
          break;
        }
        el = el.parentElement;
      } while (true);
      if ((el==DragContainer)||(el==null)) break;
    } while (true);
  }

//**  
//
//  
  SaveDragConnection(TheObj,DragItem,Count)
  { var ndnm,el1,el2,cls; 
    

    if (DragItem.hasAttribute('vc-dragclone'))
    { DragItem.id = DragItem.getAttribute('vc-clonedid') + ":Clone" + Count; 
    }
    el1 = DragItem.parentElement;
    if (el1==null) return;
   
    if (el1.nodeName!='VC-DRAGCONTAINER') return;
    el2 = el1.parentElement;
    if (el2.nodeName=='VC-DRAGITEM') el1 = el2;
    cls = "";
    el2 = this.GetDragCloseButton(DragItem);
    if (el2!=null)
    { if ((el2.GetState())) cls = ":DragCloseButton";
    }
    TheObj[DragItem.id] = el1.id + cls;
  }
  
//**  
//Make the given valid vcDragItem selected
//  
  SelectDragItem(DragItem)
  { var par = DragItem.parentNode;
    var ix  = DragItem.GroupIx;
    if (vcDragSingle.SelOwners[ix]!=par)
    { if (vcDragSingle.SelOwners[ix]!=null)
        this.ClearSelection(ix);
      vcDragSingle.SelOwners[ix] = par;
    }
    DragItem.setAttribute('vc-selected','true');
  }
  
  XferDragItem(DragItem,Container,Target,Clone,KeepChildItems)
  { var el;
    if (DragItem.nodeName!='VC-DRAGITEM') return null;
    el = DragItem;
		if (typeof Clone !== "undefined")
    { if (Clone)
    	{ el = DragItem.cloneNode(true);
      	if (!(DragItem.hasAttribute("vc-dragclone")))
      	{ el.setAttribute("vc-clonedid",DragItem.id);
        	el.removeAttribute('id');
        	el.setAttribute("vc-dragclone","");
        	el.setAttribute("vc-candelete","");
      	}
        if (typeof KeepChildItems !== "undefined")
        { if (!KeepChildItems)
        	{ var chl,nxt;
            chl = this.GetChildContainer(el);
            if (chl!=null) chl = chl.firstElementChild;
            while (chl!=null)
            { nxt = chl.nextElementSibling;
              if (chl.nodeName=='VC-DRAGITEM') chl.remove();
              chl = nxt;
            }
        	}
        }
      }
    }
    if (Target==Container)
          Target.appendChild(el);
    else 
    { if (el!=Target) 
        Container.insertBefore(el,Target);
    }
    return el;
  }
  
}